"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _lodash = require("lodash.values");

var _lodash2 = _interopRequireDefault(_lodash);

var _jestSnapshot = require("jest-snapshot");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buildMatchSnapshot = function buildMatchSnapshot(utils, parseArgs) {
  return function matchSnapshot() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _parseArgs = parseArgs(args);

    var snapshotFilename = _parseArgs.snapshotFilename;
    var snapshotName = _parseArgs.snapshotName;
    var update = _parseArgs.update;


    if (utils.flag(this, 'negate')) {
      throw new Error("`matchSnapshot` cannot be used with `.not`.");
    }

    var obj = this._obj;
    var absolutePathToSnapshot = _path2.default.resolve(snapshotFilename);

    var snapshotState = new _jestSnapshot.SnapshotState(void 0, {
      updateSnapshot: update ? "all" : "new",
      snapshotPath: absolutePathToSnapshot
    });

    var _snapshotState$match = snapshotState.match(snapshotName, obj, snapshotName);

    var actual = _snapshotState$match.actual;
    var expected = _snapshotState$match.expected;
    var pass = _snapshotState$match.pass;

    snapshotState.save();

    this.assert(pass, "expected value to match snapshot " + snapshotName, "expected value to not match snapshot " + snapshotName, expected.trim(), actual.trim(), true);
  };
};

exports.default = buildMatchSnapshot;